// DRB 24-Nov-2008
// An example of C-callable assembly functions

#include <stdio.h>
#define N 100
//#pragma DATA_ALIGN(xx,8);		// align xx array on 64-bit (8-byte) boundary
//#pragma DATA_ALIGN(yy,8);		// align yy array on 64-bit (8-byte) boundary

// function prototypes
float donothing(float);
float test_asm(float a, float b);
float dotproduct1(float*, float*, int); 
float dotproduct2(float*, float*, int); 
float dotproduct3(float*, float*, int);
float dotproduct4(float*, float*, int);

// global variables
float x, y, z;
float xx[N];
float yy[N];

void main(void)
{

	// local variables
	float a, b, c, zz;
	int n;
	
	// initialize arrays
	for (n=0;n<N;n++){
		xx[n] = n+1;
		yy[n] = N+n+1;
	}

	printf("This part of the program calls the donothing function.\n");

	a = 0;
	b = 0;
    a = donothing(b);

	printf("This part of the program computes a*x + b = c where x is global.\n");

	x = 3.14159;
	a = 0.707;
	b = 2.789;
	c = test_asm(a,b);

	printf("%f*%f + %f = %f\n",a,x,b,c);

	printf("This part of the program computes the dot products.\n");
	zz = dotproduct1(xx,yy,N);
	printf("dotproduct1 zz = %f\n",zz);
	zz = dotproduct2(xx,yy,N);
	printf("dotproduct2 zz = %f\n",zz);
	zz = dotproduct3(xx,yy,N);
	printf("dotproduct3 zz = %f\n",zz);
	zz = dotproduct4(xx,yy,N);
	printf("dotproduct4 zz = %f\n",zz);

}
